<i18n lang="yml">
  en:
    ranking: "Ranking"
    ranking_old: "Previous rank"
    ranking_new: "New rank"
    district: "District"
    odk: "ODK"
    odk_b: "%B"
    odk_scans: "[scans]"
    crow: "CROW"
    crow_b: "%B"
    crow_observed: "[schouw]"
  nl:
    ranking: "Rang"
    ranking_old: "Vorige rang"
    ranking_new: "Nieuwe rang"
    district: "Stadsdeel"
    odk_scans: "[scans]"
    crow_observed: "[schouw]"
</i18n>

<template>
  <AmsTableGroup :class="$style['toploc-tbody']">
    <template v-if="STATE.loaded.topLocDistricts">
      <template v-for="(row, rIndex) of rows">
        <template v-if="STATE.filters.valueFor.district === 'all' || STATE.filters.valueFor.district === row.district.value">
          <AmsTableRow
            :key="rIndex"
            :is-actionable="true"
            :has-shadow="true"
            :is-active="STATE.filters.valueFor.district === row.district.value"
            :disabled="!row.odk_scans.value > 0"
            tabindex="0"
            @keydown.enter.native="inspectDistrict(
              row.district.value,
              disabled = !row.odk_scans.value > 0,
              $event,
            )"
            @keydown.space.native="inspectDistrict(
              row.district.value,
              disabled = !row.odk_scans.value > 0,
              $event,
            )"
            @click.capture.native="inspectDistrict(
              row.district.value,
              disabled = !row.odk_scans.value > 0,
              $event,
            )"
          >
            <!-- Content cells -->
            <template v-for="(cell, cIndex) of Object.values(row).filter(cell => cell && typeof cell.id !== 'undefined')">
              <AmsTableCell
                v-show="!cell.isHidden"
                :key="cIndex"
                :ref="cell.id"
                :class="$style[`cell-${cell.id}`]"
                :style="cell.style"
              >
                <div
                  :class="[
                    $style['content'],
                    $style[cell.id],
                    'relative',
                  ]"
                >
                  <div :title="$t(`${cell.id}: ${cell.value}`)">
                    {{ `${$t(cell.prefix)}${$t(`${cell.value}`)}${$t(cell.suffix)}` }}
                  </div>

                  <AmsProgressBar
                    v-if="cell.showProgressBar"
                    :progress="cell.value"
                  />
                </div>
              </AmsTableCell>
            </template>
          </AmsTableRow>

          <!-- Empty rows for layout purposes as `tr` elements cannot have margin's. -->
          <AmsTableRow
            :key="`empty_row_${rIndex}x`"
            :is-empty="true"
          >
            <td :colspan="numberOfCells" />
          </AmsTableRow>
        </template>
      </template>
    </template>

    <!-- Loading rows indicators -->
    <template v-else>
      <template v-for="row of 5">
        <AmsTableRowLoading :key="row" />
        <AmsTableRow :key="`empty_${row}`" :empty="true">
          <AmsTableCell style="padding: 0;" />
        </AmsTableRow>
      </template>
    </template>
  </AmsTableGroup>
</template>

<script lang="ts">
import {
  computed,
  defineComponent,
  inject,
} from "@nuxtjs/composition-api";

export default defineComponent({
  name: "AmsScansTable",

  components: {
    AmsTableGroup: () => import("~/components/_elements/Table/TableGroup.vue"),
    AmsTableRow: () => import("~/components/_elements/Table/TableRow.vue"),
    AmsTableRowLoading: () => import("~/components/_elements/Table/TableRowLoading.vue"),
    AmsTableCell: () => import("~/components/_elements/Table/TableCell.vue"),
    AmsProgressBar: () => import("~/components/_elements/Indicators/ProgressBar.vue"),
  },

  props: {
    rows: {
      type: Array,
      default: () => [],
    },
  },

  setup (props) {
    const { STATE } = inject("store");

    const numberOfCells = computed(() => Object.keys(props.rows[0]).length);

    function inspectDistrict (district, disabled, $event) {
      $event.preventDefault();

      if (disabled) {
        return;
      }

      STATE.filters.valueFor.cluster_location = "";

      if (STATE.filters.valueFor.district === district) {
        STATE.filters.valueFor.district = "all";
        // @ts-ignore
        document.activeElement.blur();
      } else {
        STATE.filters.valueFor.district = district;
      }
    }

    return {
      STATE,
      numberOfCells,
      inspectDistrict,
    };
  },
});
</script>

<style lang="postcss" module>
.toploc-tbody {
  transition: height 500ms ease-out;
  overflow-x: visible;

  @apply overflow-y-auto;

  th,
  td {
    @apply p-2 bg-white align-top;

    &.cell-ranking_old {
      @apply bg-gray-100;
    }

    &.cell-ranking_old,
    &.cell-ranking_new {
      width: 3rem;

      @apply font-medium;
    }

    &.cell-district {
      min-width: 6rem;

      @apply font-medium;
    }

    &.cell-odk_b,
    &.cell-crow_b,
    &.cell-odk_scans,
    &.cell-crow_observed {
      width: 12.5%;
      min-width: 5rem;

      @apply leading-snug;

      .content {
        width: min-content;
      }
    }

    &:first-of-type {
      @apply rounded-l-sm;
    }

    &:last-of-type {
      @apply rounded-r-sm;
    }

    .content {
      @apply block py-2 h-8;

      & > span {
        @apply inline-flex w-full;
      }
    }
  }
}

.icon {
  transition: transform 250ms ease;

  @apply flex justify-center items-center;

  svg {
    width: 14px;
    height: 14px;
  }
}
</style>
